package infovis;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.font.FontRenderContext;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.util.Vector;

public class Achsen {

	public Color mColor=new Color(0.5f,0.5f,0.5f,1.0f);
	public Vector<Line2D> lines=new Vector<Line2D>();
	public Vector<Label> labels=new Vector<Label>();
	
	public Achsen(){}
	
	public Achsen clone(){
		Achsen ret=new Achsen();
		ret.mColor=new Color(this.mColor.getRed(), this.mColor.getGreen(),this.mColor.getBlue(),this.mColor.getAlpha());
		for(int i=0; i<lines.size(); i++) ret.lines.add((Line2D)lines.get(i).clone());
		for(int i=0; i<labels.size(); i++) ret.labels.add(labels.get(i).clone());
		
		return ret;
	}
	
	public void addLabel(String s, float x, float y){
		labels.add(new Label(s,x,y));
	}
	
	public void draw(Graphics2D g2){
		g2.setColor(mColor);		
		g2.setStroke( new BasicStroke(0.002f) );
		
		for(int i=0; i<lines.size(); i++) g2.draw(lines.get(i));
	
		g2.scale(0.01f,-0.01f);
		g2.setFont(new Font("Times New Roman", Font.PLAIN, 4));
		
		for(int i=0; i<labels.size(); i++){
			Label l=labels.get(i);
			//System.out.println(l.s+" "+l.x+" "+l.y);
			
			Text(g2,l.s,l.x*100.0f,-l.y*100.0f);	
		}
		
		g2.scale(100.0f,-100.0f);
		
	}
	
	protected void Text(Graphics2D g2, String s, float centerX, float centerY) {
		FontRenderContext frc = g2.getFontRenderContext();
	    Rectangle2D bounds = g2.getFont().getStringBounds(s, frc);
	    float width = (float) bounds.getWidth();
	    float height = (float) bounds.getHeight();
	    
	    g2.drawString(s, centerX - width / 2, centerY  );
	}
	
	public class Label{
		public String s;
		float x,y;
		
		public Label clone(){
			return new Label(this.s, this.x, this.y);
		}
		
		public Label(String s, float x, float y){
			this.s=s;
			this.x=x;
			this.y=y;			
		}
	}
	
}

