package infovis;
import java.awt.geom.*;
import java.awt.*;

public class DrawObject {

	public Color mColor=new Color(0.0f,0.0f,0.0f,1.0f);
	public Point2D.Float mPosition=new Point2D.Float(0.0f,0.0f);
	public float mRotation=0.0f;
	public float[] mShape=null;
	
	public DrawObject(){}
	
	public DrawObject clone(){
		DrawObject obj=new DrawObject();
		obj.mColor=new Color(this.mColor.getRed(), this.mColor.getGreen(),this.mColor.getBlue(),this.mColor.getAlpha());
		obj.mPosition=new Point2D.Float(this.mPosition.x, this.mPosition.y);
		obj.mRotation=this.mRotation;
		if(mShape!=null) obj.mShape=this.mShape.clone();
		return obj;
	}
	
	public void draw(Graphics2D g2){
		g2.setColor(mColor);
		
		g2.translate(mPosition.getX(),mPosition.getY());
		
		if(mRotation!=0.0f) g2.rotate(mRotation);
		
		//for(int i=0; i<mShape.length; i+=2) g2.fill(new Rectangle2D.Float(mShape[i],mShape[i+1],0.01f,0.01f)); 
		
		if(mShape!=null) {
			GeneralPath p = new GeneralPath(GeneralPath.WIND_NON_ZERO);
			
			p.moveTo(mShape[0],mShape[1]);
			for(int i=2; i<mShape.length; i+=2) p.lineTo(mShape[i],mShape[i+1]);
	
			p.closePath();
			g2.fill(p);
//			g2.draw(p);

		}
		
	
		if(mRotation!=0.0f) g2.rotate(-mRotation);
		
		g2.translate(-mPosition.getX(),-mPosition.getY());	
	}
	
}
