package infovis;

import infovis.chartgenerators.DataCollection;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;
import java.util.Vector;



public class Graph {
	public final static int BARCHART=0; 
	public final static int SCATTERPLOT=1; 
	public final static int PIECHART=2; 
	
	public Vector<DrawObject> mObj=new Vector<DrawObject>();
	public String mName="";
	public int mType;
	public DataCollection mData=null;
	
	public Achsen a1=null, a2=null;
	
	public Graph(int type){
		mType=type;
	}
	
	public void draw(Graphics2D g2){
		if(a1!=null) a1.draw(g2);
		if(a2!=null) a2.draw(g2);
		
		for(int i=0; i<mObj.size(); i++) mObj.get(i).draw(g2);
	}
	
	public Graph clone(){
		Graph g=new Graph(this.mType);
		
		if(a1!=null) g.a1=this.a1.clone();
		if(a2!=null) g.a1=this.a2.clone();
		
		for(int i=0; i<mObj.size(); i++) g.mObj.add(mObj.get(i).clone());
		
		if(this.mData!=null) g.mData=this.mData.clone();
		return g;
	}
	
}
