package infovis;

import infovis.blend.ColorBlend;
import infovis.blend.PositionBlend;
import infovis.blend.RotationBlend;
import infovis.blend.ShapeBlend;
import infovis.chartgenerators.BarChartGenerator;
import infovis.chartgenerators.PieChartGenerator;
import infovis.chartgenerators.ScatterPlotGenerator;

import java.applet.Applet;
import java.awt.BasicStroke;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.*;

import javax.swing.*;


import java.awt.event.*;
import java.awt.Color;
import java.util.Vector;
import java.awt.event.*; 
import java.awt.font.FontRenderContext;
import java.awt.Color;


public class InfoVis extends Applet implements KeyListener, MouseListener, Runnable{

	MyCanvas canvas;
	
	Graph mGraph=null;
	Thread t;
	
	transitionGenerator tg=new transitionGenerator();
	Transition mTrans=null;
	JFrame f=null;

	boolean running;
	
	int mPlaying=-1;
	Vector<TransEntry> Transitions=new Vector<TransEntry>();
	
	String TransitionName="";
	
	public static void main(String[] args) {
		InfoVis iv=new InfoVis();
		iv.init_standalone();
	}
	
	public void init() {
		canvas=new MyCanvas(this);
		canvas.setSize(this.getWidth(), this.getHeight());
	    this.add(canvas);
		canvas.addMouseListener(this);
		
		canvas.addKeyListener(this );
		canvas.requestFocus();
		
		test();
	}

	public void stop() {
	}
	
	public void init_standalone(){
		f=new JFrame("InfoVis");
		
		f.setTitle("InfoVis");
		
		f.addComponentListener(new MyComponentAdapterAdapter(this) );
				
		f.addWindowListener(new MyWindowAdapter() );
		f.setSize(1024, 768);
		
	    Toolkit toolkit = Toolkit.getDefaultToolkit();
	    Dimension screenSize = toolkit.getScreenSize();
	    
		int x = (screenSize.width - f.getWidth()) / 2;
	    int y = (screenSize.height - f.getHeight()) / 2;
	    
	    f.setLocation(x, y);
	    
	    canvas=new MyCanvas(this);
	    f.add(canvas);
	    
		f.setVisible(true);
		
		canvas.addMouseListener(this);
		canvas.addKeyListener(this );
		canvas.requestFocus();

		test();
	}

	
	public void draw(Graphics g) 
    {
		
		if(g!=null){
		
		Dimension d=null;
		Image offscreen=null;
		
		if(f!=null) {
			d=f.getContentPane().getSize();
			offscreen=f.createImage(d.width,d.height);
		} else {
			d=this.getSize();
			offscreen=this.createImage(d.width,d.height);
		}
		
		if(offscreen!=null){
			
			Graphics2D g2 = (Graphics2D) offscreen.getGraphics();
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
					
			float scale;
			float xoffset=0.0f;
			float yoffset=0.0f;
			if (canvas.getWidth()<canvas.getHeight()){
				scale=canvas.getWidth();
				yoffset=(canvas.getHeight()-canvas.getWidth())/scale*0.5f;
			} else {
				scale=canvas.getHeight();
				xoffset=(canvas.getWidth()-canvas.getHeight())/scale*0.5f;
			}
			
			g2.setColor(Color.WHITE);
			g2.fillRect(0,0,canvas.getWidth(),canvas.getHeight());
			
			
			g2.scale(scale,-scale);
			g2.translate(xoffset,-1.0f-yoffset);
			
			
			g2.scale(0.010f,-0.01f);
			g2.setFont(new Font("Times New Roman", Font.PLAIN, 5));
			g2.setColor(Color.BLACK);
			paintHorizontallyCenteredText(g2,TransitionName,50.0f,-100.0f+5.0f);
			g2.scale(100.0f,-100.0f);
			
			g2.translate(0.1f,0.05f);
			g2.scale(0.8f,0.8f);
				
			if(mGraph!=null) mGraph.draw(g2);
			
			g.drawImage(offscreen,0,0,this);
		}
		}
    }
	
	protected void paintHorizontallyCenteredText(Graphics2D g2, String s, float centerX, float centerY) {
		FontRenderContext frc = g2.getFontRenderContext();
	    Rectangle2D bounds = g2.getFont().getStringBounds(s, frc);
	    float width = (float) bounds.getWidth();
	    float height = (float) bounds.getHeight();
	    
	    g2.drawString(s, centerX - width / 2, centerY  );
	}
	

	public void test(){
		
		Graph barchart1, barchart2, barchart3, barchart4, scatterplot1, scatterplot2, scatterplot3, piechart;

		BarChartGenerator bcg1=new BarChartGenerator();
		bcg1.add("A", 0.2f);
		bcg1.add("B", 1.3f);
		bcg1.add("C", 2.3f);
		bcg1.add("D", 1.2f);
		bcg1.add("E", 2.0f);
		bcg1.add("F", 3.0f);
		
		barchart1=bcg1.generate();
		
		BarChartGenerator bcg2=new BarChartGenerator();
		
		bcg2.add("A", 0.2f);
		bcg2.add("B", null);
		bcg2.add("C", 2.3f);
		bcg2.add("D", null);
		bcg2.add("E", 2.0f);
		bcg2.add("F", null);
		
		barchart2=bcg2.generate();
		
		BarChartGenerator bcg3=new BarChartGenerator();
		bcg3.add("F", 5,0.2f);
		bcg3.add("C", 2,1.3f);
		bcg3.add("E", 4,2.3f);
		bcg3.add("B", 1,1.2f);
		bcg3.add("D", 3,2.0f);
		bcg3.add("A", 0,3.0f);
		
		barchart3=bcg3.generate();
		
		BarChartGenerator bcg4=new BarChartGenerator();
		bcg4.add("A", 3.6f);
		bcg4.add("B", 0.2f);
		bcg4.add("C", 1.3f);
		bcg4.add("D", 1.8f);
		bcg4.add("E", 1.0f);
		bcg4.add("F", 2.2f);
		
		barchart4=bcg4.generate();
		
		ScatterPlotGenerator scg1=new ScatterPlotGenerator();
		
		scg1.add("A", 1.2f, 0.2f);
		scg1.add("B", 1.8f, 1.3f);
		scg1.add("C", 5.5f, 2.3f);
		scg1.add("D", 4.1f, 1.2f);
		scg1.add("E", 2.3f, 2.0f);
		scg1.add("F", 1.5f, 3.0f);
		
		scatterplot1=scg1.generate();

		ScatterPlotGenerator scg2=new ScatterPlotGenerator();
		
		scg2.add("A", 4.2f, 1.2f);
		scg2.add("B", 2.3f, 1.3f);
		scg2.add("C", 2.5f, 5.3f);
		scg2.add("D", 3.1f, 3.2f);
		scg2.add("E", 0.3f, 0.1f);
		scg2.add("F", 2.9f, 2.2f);
		
		scatterplot2=scg2.generate();

		ScatterPlotGenerator scg3=new ScatterPlotGenerator();
		
		scg3.add("A", 1.2f, 0.2f);
		scg3.add("B", 1.8f, 1.3f);
		scg3.add("C", null);
		scg3.add("D", 4.1f, 1.2f);
		scg3.add("E", 2.3f, 2.0f);
		scg3.add("F", null);
		
		scatterplot3=scg3.generate();

		PieChartGenerator pcg=new PieChartGenerator();
		
		pcg.add("A",1.0f);
		pcg.add("B",1.3f);
		pcg.add("C",2.3f);
		pcg.add("D",1.2f);
		pcg.add("E",2.0f);
		pcg.add("F",3.0f);
		
		piechart=pcg.generate();
		
		Transitions.add(new TransEntry(barchart1,barchart2,"Bar-Chart Focus Example I (Fade Out)",2.0f));
		Transitions.add(new TransEntry(barchart2,barchart1,"Bar-Chart Focus Example II (Blend In)",2.0f));
		Transitions.add(new TransEntry(barchart1,barchart4,"Bar-Chart Value Change",2.0f));
		Transitions.add(new TransEntry(barchart1,barchart3,"Bar-Chart Ordering Example",2.0f));
		
		Transitions.add(new TransEntry(barchart1,piechart,"Bar-Chart to Pie-Chart",2.0f));
		Transitions.add(new TransEntry(piechart,barchart1,"Pie-Chart to Bar-Chart",2.0f));
		
		
		Transitions.add(new TransEntry(scatterplot1,scatterplot3,"Scatter-Plot Focus Example I (Fade Out)",2.0f));
		Transitions.add(new TransEntry(scatterplot3,scatterplot1,"Scatter-Plot Focus Example II (Blend In)",2.0f));
		Transitions.add(new TransEntry(scatterplot1,scatterplot2,"Scatter-Plot Value Change",2.0f));
			
		
		Transitions.add(new TransEntry(scatterplot1,piechart,"Scatter-Plot to Pie-Chart",2.0f));
		Transitions.add(new TransEntry(piechart,scatterplot1,"Pie-Chart to Scatter-Plot",2.0f));
		Transitions.add(new TransEntry(barchart1,scatterplot1,"Bar-Chart to Scatter-Plot",2.0f));
		Transitions.add(new TransEntry(scatterplot1,barchart1,"Scatter-Plot to Bar-Chart",2.0f));
		
		
		mGraph=Transitions.get(0).src.clone();
		
	}

	public void repaint(){
		if(canvas!=null) this.draw(canvas.getGraphics());
	}
	
	public void paint(Graphics g){
		if(canvas!=null) this.draw(g);
	}
	
	  static class MyComponentAdapterAdapter extends ComponentAdapter {
		  private InfoVis p;
		  
		  public MyComponentAdapterAdapter(InfoVis p){
			this.p=p;  
		  }
			public void componentResized(ComponentEvent evt) {
				p.repaint();
			}
		}

		static class MyWindowAdapter extends WindowAdapter {
			public void windowClosing (WindowEvent e) {
				System.exit(0);
			}
		}
		
		static class MyCanvas extends java.awt.Canvas
		{
			InfoVis p;
			
		    public MyCanvas(InfoVis p)
		    {
		    	this.p=p;
		    }

		    public void paint(Graphics g)
		    {
		    	p.draw(g);
		    } 
		    
		    public void repaint(){
		    }

		}

		public void keyTyped(KeyEvent arg0) {
		}

		public void keyPressed(KeyEvent arg0) {
		}

		public void keyReleased(KeyEvent arg0) {
				switch (arg0.getKeyCode()) {
			    	case KeyEvent.VK_LEFT: skip(false); break;
			    	case KeyEvent.VK_RIGHT:  skip(true); break;
				}
		}
		
		public void mouseClicked(MouseEvent arg0) {
			if(arg0.getButton()==MouseEvent.BUTTON1) skip(true); else skip(false);
		}

		public void mousePressed(MouseEvent arg0) {
		
		}

		public void mouseReleased(MouseEvent arg0) {
			
		}

		public void mouseEntered(MouseEvent arg0) {
			
		}

		public void mouseExited(MouseEvent arg0) {
			
		}
		
		public void skip(boolean forward){
				
			if(forward) mPlaying++; else mPlaying--;
			
			
			if(mPlaying>=Transitions.size()) mPlaying=0;
			if(mPlaying<0) mPlaying=Transitions.size()-1;
					
			TransitionName=Transitions.get(mPlaying).name;
			
			Graph src=Transitions.get(mPlaying).src.clone();
			Graph dst=Transitions.get(mPlaying).dst.clone();
		
			mTrans=tg.generate(Transitions.get(mPlaying).duration, src,dst);
			mGraph=tg.getGraph();
		
			mTrans.start();
			
			t=new Thread(this);
			t.start();
		
		}


		public synchronized void run() {
			while(mTrans.active()){
				mTrans.update();
				repaint();
			}
		}

	public class TransEntry{
		public Graph src, dst;
		public String name;
		public float duration;
		
		TransEntry(Graph src, Graph dst, String name, float duration){
			this.src=src;
			this.dst=dst;
			this.name=name;
			this.duration=duration;
		}
		
	}
}