package infovis;

import infovis.blend.Blend;
import infovis.blend.BlendingFunction;
import infovis.blend.SlowInSlowOutBlending;

import java.util.*;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Color;

public class Transition {

	//BlendingFunction bf=new LinearBlending();
	BlendingFunction bf=new SlowInSlowOutBlending();
	
	Vector<Blend> mBlends=new Vector<Blend>();
	Vector<Transition> mChilds=new Vector<Transition>();
	
	float duration; // in seconds
	
	float start=0.0f;
	float end=1.0f;
	
	private long starttime=0;
	
	boolean running=false;
	boolean finished=false;
	
	public Transition(float duration){
		this.start=0.0f;
		this.end=1.0f;	
		this.duration=duration;
	}
	
	public Transition(float start, float end){
		this.start=start;
		this.end=end;
	}
	
	public void add(Blend b){
		mBlends.add(b);
	}
	
	public void addAll(Vector<Blend> b){
		mBlends.addAll(b);
	}
	
	public void add(Transition t){
		mChilds.add(t);
	}
	
	public void start(){
		finished=false;
		running=true;
		starttime=new Date().getTime();
	}
	
	public boolean active(){
		return running;
	}
	
	public void update(float f){
		
		if(finished) return;
		
		f=(f-start)/(end-start);
		
		if(f<=0) return;
		
		running=true;
		
		if(f>1) {
			f=1.0f;
			finished=true;
			running=false;
		}
		
		float d=bf.getBlend(f);
		
		for(int i=0; i<mBlends.size(); i++) mBlends.get(i).blend(d);
		for(int i=0; i<mChilds.size(); i++) mChilds.get(i).update(f);
	}
	
	public void update(){
		
		if(finished) return;
		
		long time=new Date().getTime();
		float f=((float)(time-starttime))/duration*1.000f;
		
		if(f<=0) return;
		
		if(f>1) {
			f=1.0f;
			finished=true;
			running=false;
		}
		
		float d=bf.getBlend(f);
		
		for(int i=0; i<mBlends.size(); i++) mBlends.get(i).blend(d);
		for(int i=0; i<mChilds.size(); i++) mChilds.get(i).update(f);
		
	}
	
	
}
