package infovis.blend;
import infovis.Achsen;
import infovis.DrawObject;
import infovis.Graph;

import java.awt.Color;
import java.util.Vector;
	
public class ColorBlend extends BlendAbstract {
	
	float[] d,o;
	Achsen mAchsen=null;
	
	public ColorBlend(Achsen achsen, boolean in){
		super(null,null,null);
		
		if(achsen!=null){
			mAchsen=achsen;
		
			o=achsen.mColor.getComponents(null);
			d=achsen.mColor.getComponents(null);
			
			if(in) o[3]=0.0f; else d[3]=0.0f;
			
			for(int i=0; i<4; i++) d[i]=d[i]-o[i];
			
			blend(0.0f);
		}
	}
	
	public ColorBlend(DrawObject obj, DrawObject src, DrawObject dst){
		super(obj,src,dst);
		
		o=src.mColor.getComponents(null);
		d=dst.mColor.getComponents(null);
		
		for(int i=0; i<4; i++) d[i]=d[i]-o[i];
	}
	
	public void blend(float i) {
		if(obj!=null) obj.mColor=new Color(o[0]+d[0]*i, o[1]+d[1]*i, o[2]+d[2]*i, o[3]+d[3]*i);
		if(mAchsen!=null) mAchsen.mColor=new Color(o[0]+d[0]*i, o[1]+d[1]*i, o[2]+d[2]*i, o[3]+d[3]*i);
	}
	
	public Vector<Blend> many(Graph o, Graph src, Graph dst){
		Vector<Blend> many=new Vector<Blend>();
		for(int i=0; i<o.mObj.size(); i++) many.add(new ColorBlend(o.mObj.get(i),src.mObj.get(i),dst.mObj.get(i))); 
		return many;
	}
}
