package infovis.blend;

import infovis.DrawObject;
import infovis.Graph;

import java.awt.geom.*;
import java.util.Vector;

public class PositionBlend extends BlendAbstract {

	float[] d,o;
	
	public PositionBlend(){
		super(null,null,null);
	}
	
	public PositionBlend(DrawObject obj, DrawObject src, DrawObject dst){
		super(obj,src,dst);
	
		o=new float[2];
		o[0]=(float)src.mPosition.getX();
		o[1]=(float)src.mPosition.getY();

		d=new float[2];
		d[0]=(float)dst.mPosition.getX();
		d[1]=(float)dst.mPosition.getY();

		for(int i=0; i<d.length; i++) d[i]=d[i]-o[i];
	}
	
	public void blend(float i) {
		obj.mPosition.setLocation(o[0]+d[0]*i, o[1]+d[1]*i);
	}
	
	public Vector<Blend> many(Graph o, Graph src, Graph dst){
		Vector<Blend> many=new Vector<Blend>();
		for(int i=0; i<o.mObj.size(); i++) many.add(new PositionBlend(o.mObj.get(i),src.mObj.get(i),dst.mObj.get(i))); 
		return many;
	}
		
}
