package infovis.blend;

import infovis.DrawObject;
import infovis.Graph;

import java.util.Vector;
import java.lang.Math.*;

public class PositionRadialBlend extends BlendAbstract  {

	
	double r,r_delta;
	double theta,theta_delta;
	
	float CenterX=0.5f;
	float CenterY=0.5f;
	
	public PositionRadialBlend(){
		super(null,null,null);
	
		
	}
	
	public PositionRadialBlend(DrawObject obj, DrawObject src, DrawObject dst){
		super(obj,src,dst);
	
		double x1=(double)src.mPosition.getX()-CenterX;
		double y1=(double)src.mPosition.getY()-CenterY;
		double x2=(double)dst.mPosition.getX()-CenterX;
		double y2=(double)dst.mPosition.getY()-CenterY;

		r=len(x1,y1);
		theta=getAngle(x1,y1);
		
		r_delta=len(x2,y2)-r;
		theta_delta=getAngle(x2,y2)-theta;
		
	}
	
	
	 static public double getAngle(double x, double y) {  
		     // calculate angle  
		     double a = Math.atan2(x, y);  
		     // fix too large angles (beats me why are they ever generated)  
		     if (a > 2 * Math.PI) {  
		         a = a - 2 * Math.PI;  
		     }  
		     // fix atan2 output scheme to match my mental scheme  
		     if (a >= 0.0 && a <= Math.PI/2) {  
		         a = Math.PI/2 - a;  
		     } else if (a < 0 && a >= -Math.PI) {  
		         a = Math.PI/2 -a;  
		     } else if (a > Math.PI/2 && a <= Math.PI) {  
		         a = Math.PI + Math.PI + Math.PI/2 - a;  
		     }  
		     // return  
		     return a;  
		 }  
	
	public void blend(float i) {
		obj.mPosition.setLocation(
				(r+r_delta*i)*Math.cos(theta+theta_delta*i)+CenterX,
				(r+r_delta*i)*Math.sin(theta+theta_delta*i)+CenterY
		);
	}
	
	public double len(double x, double y){
		return Math.sqrt(x*x+y*y);
	}
	
	public Vector<Blend> many(Graph o, Graph src, Graph dst){
		Vector<Blend> many=new Vector<Blend>();
		for(int i=0; i<o.mObj.size(); i++) many.add(new PositionRadialBlend(o.mObj.get(i),src.mObj.get(i),dst.mObj.get(i))); 
		return many;
	}
	
}
