package infovis.blend;

import java.util.Vector;

import infovis.DrawObject;
import infovis.Graph;

public class RotationBlend extends BlendAbstract {
	
	float o,d;
	
	public RotationBlend(DrawObject obj, DrawObject src, DrawObject dst){
		super(obj,src,dst);
		o=src.mRotation;
		d=dst.mRotation-o;
		
	}
	
	public void blend(float i) {
		obj.mRotation=o+d*i;
	}

	public Vector<Blend> many(Graph o, Graph src, Graph dst){
		Vector<Blend> many=new Vector<Blend>();
		for(int i=0; i<o.mObj.size(); i++) many.add(new RotationBlend(o.mObj.get(i),src.mObj.get(i),dst.mObj.get(i))); 
		return many;
	}
}
