package infovis.blend;

import infovis.DrawObject;
import infovis.Graph;

import java.awt.geom.Point2D;
import java.util.Vector;

public class ShapeBlend extends BlendAbstract {

	float[] d,o;
	boolean nullobjects=false;
	
	public ShapeBlend(){
		super(null,null,null);
	}
	
	public ShapeBlend(DrawObject obj, DrawObject src, DrawObject dst){
		super(obj,src,dst);
	
		if(src.mShape==null||dst.mShape==null){
			nullobjects=true;
			return;
		}
		
		o=src.mShape.clone();
		d=dst.mShape.clone();
		
		for(int i=0; i<d.length; i++) d[i]=d[i]-o[i];
	}
	
	public void blend(float i) {
		if(!nullobjects)
		for(int j=0; j<obj.mShape.length; j++) obj.mShape[j]=o[j]+d[j]*i;
	}
	
	public Vector<Blend> many(Graph o, Graph src, Graph dst){
		Vector<Blend> many=new Vector<Blend>();
		for(int i=0; i<o.mObj.size(); i++) many.add(new ShapeBlend(o.mObj.get(i),src.mObj.get(i),dst.mObj.get(i))); 
		return many;
	}
}
