package infovis.chartgenerators;

import infovis.Achsen;
import infovis.DrawObject;
import infovis.Graph;
import java.awt.geom.Line2D;

import java.awt.Color;
import java.util.Vector;

public class BarChartGenerator extends DataCollection{

	public final static int MAXLINES=10;
	
	public BarChartGenerator(){}

	public Graph generate(){
		Graph g=new Graph(Graph.BARCHART);
		g.a1=new Achsen();
		
		Vector<DrawObject> obj=new Vector<DrawObject>();
		
		Float diff=getMinMax()[MaxX];
		
		float width=1.0f/(nrNoneEmpty()*2.0f+1.0f);
		float width_half=width*0.5f;
		
		int bars=0;
		
		for(int i=0; i<vec.size(); i++) {
			
			if(!vec.get(i).isNull()){
						
				DrawObject o=new DrawObject();
				
				float height=vec.get(i).x/diff;
				
				o.mShape=(new ShapeGenerator()).Box(width, height);
				o.mPosition.setLocation(bars*width*2+width+width_half,0.5f*height);
				g.a1.addLabel(vec.get(i).name, bars*width*2+width+width_half, -0.05f);
				
				o.mRotation=0.0f;
				
				o.mColor=new Color(0.0f, 0.0f, (float)getIndex(i)/(float)vec.size(), 0.9f);
				
				
				obj.add(o);
				
				bars++;
			} else {
				obj.add(new DrawObject());	
			}
		}
		
		g.mObj=obj;
		g.mData=this.clone();
		
		
		Float[] minmax=getMinMax();
		
		float diffX=minmax[MaxX];
		//float diffY=minmax[MaxY];
		
		int lines=MAXLINES;	
		
		float X=minmax[MaxX];
		float l=(float)Math.floor(X);
		
		for(int i=0; i<=X; i++){ 
			g.a1.lines.add(new Line2D.Float(0.0f, (float)i/X, 1.0f, (float)i/X));
			g.a1.addLabel(""+i, -0.05f, (float)i/X);
		}
		
		return g;
	}	
}
