package infovis.chartgenerators;

import java.util.*;

public class DataCollection {

	public static int MinX=0;
	public static int MaxX=1;
	public static int MinY=2;
	public static int MaxY=3;
	public static int SumX=0;
	public static int SumY=1;
	
	public Vector<Data> vec=new Vector<Data>();
	
	public DataCollection(){
	}
	
	public DataCollection clone(){
		DataCollection dc=new DataCollection();
		
		Data[] out=vec.toArray(new Data[0]);
		
		for(int i=0; i<out.length; i++) dc.vec.add(out[i].clone());
		
		return dc;
	}
	
	public void skip(){
		vec.add(new Data(null, nextFreeID(), null));
	}
	
	public void add(String name, int id, Float x){
		Data d=new Data(name, id, x);
		vec.add(d);
	}
	
	public void add(String name, int id, Float x, Float y){
		Data d=new Data(name, id, x,y);
		vec.add(d);
	}
	
	public void add(String name, Float x){
		vec.add(new Data(name, nextFreeID(), x));
	}
	
	public void add(String name, Float x, Float y){
		int id=nextFreeID();
		Data d=new Data(name, id, x,y);
		vec.add(d);		
	}
	
	public int nextFreeID(){
		int freeID=0;
		
		while(getIndex(freeID)!=null) freeID++;
		
		return freeID;
	}
	
	public Integer getIndex(int id){
		Data[] out=vec.toArray(new Data[0]);
		
		for(int i=0; i<out.length; i++) {
			if(out[i].id==id) return i;
		}
		
		return null;
	}

	public int nrNoneEmpty(){
		int noneempty=0;
		
		Data[] out=vec.toArray(new Data[0]);
		
		for(int i=0; i<out.length; i++) 
			if(!out[i].isNull()) noneempty++;
		
		return noneempty;
	}
	
	public Float[] getMinMax(){
		Float[] s=new Float[4];
		
		s[MinX]=null;
		s[MaxX]=null;
		s[MinY]=null;
		s[MaxY]=null;
		
		Data[] out=vec.toArray(new Data[0]);
		
		for(int i=0; i<out.length; i++) {
			if(!out[i].isNull()){
				
				if(out[i].x!=null&&s[MinX]!=null) {
					if(s[MinX]>=out[i].x) s[MinX]=out[i].x;
					if(s[MaxX]<=out[i].x) s[MaxX]=out[i].x;
				}
				
				if(out[i].x!=null&&s[MinX]==null) {
					s[MinX]=out[i].x;
					s[MaxX]=out[i].x;
				}
				
				if(out[i].y!=null&&s[MinY]!=null) {
					if(s[MinY]>=out[i].y) s[MinY]=out[i].y;
					if(s[MaxY]<=out[i].y) s[MaxY]=out[i].y;
				}
				
				if(out[i].y!=null&&s[MinY]==null) {
					s[MinY]=out[i].y;
					s[MaxY]=out[i].y;
				}
				
			}
		}
		
		return s;
	}

	public boolean orderingEquals(){
		for(int i=0; i<vec.size(); i++) if(i!=getIndex(i)) return false;
		
		return true;
	}
	
	public Float[] sum(){
		Float[] sum=new Float[2];
		sum[SumX]=null;
		sum[SumY]=null;
		
		Data[] out=vec.toArray(new Data[0]);
		
		for(int i=0; i<out.length; i++) {
			if(!out[i].isNull()){
				if(out[i].x!=null&&sum[SumX]!=null) sum[SumX]+=out[i].x;
				if(out[i].x!=null&&sum[SumX]==null) sum[SumX]=out[i].x;
				if(out[i].y!=null&&sum[SumY]!=null) sum[SumY]+=out[i].y;				
				if(out[i].y!=null&&sum[SumY]==null) sum[SumY]=out[i].y;
			}
		}
		
		return sum;
	}
	
	/*public void debug(){
		
		System.out.println("minmax x:"+getMinMax()[MinX]+" "+getMinMax()[MaxX]);
		System.out.println("minmax y:"+getMinMax()[MinY]+" "+getMinMax()[MaxY]);
		
		System.out.println("sum:"+sum()[0]+" "+sum()[1]);
		
		Data[] out=vec.toArray(new Data[0]);
		for(int i=0; i<out.length; i++) {
			if (out[i]!=null) out[i].debug();  
		}
	}*/
}
