package infovis.chartgenerators;

import infovis.Achsen;
import infovis.DrawObject;
import infovis.Graph;

import java.awt.Color;
import java.util.Vector;

public class PieChartGenerator extends DataCollection{

	float radius=0.3f;
	
	public PieChartGenerator(){
		
	}
	
	
	public Graph generate(){
		Graph g=new Graph(Graph.PIECHART);
		g.a1=new Achsen();
		
		Vector<DrawObject> obj=new Vector<DrawObject>();
		
		float sum=this.sum()[SumX];
		
		float ang=0.0f;
		
		for(int i=0; i<vec.size(); i++) {
			if(!vec.get(i).isNull()){	
				DrawObject o=new DrawObject();
					
				float val=vec.get(i).x/sum;
				
				o.mShape=(new ShapeGenerator()).Pie(radius,val,ang);
				o.mPosition.setLocation(0.5f+Math.cos(2.0f*Math.PI*(ang+0.25f+val*0.5f))*radius*0.5f,
										0.5f+Math.sin(2.0f*Math.PI*(ang+0.25f+val*0.5f))*radius*0.5f);
				
				o.mRotation=0.0f;
				o.mColor=new Color(0.0f, 0.0f, (float)getIndex(i)/(float)vec.size(), 0.9f);
				
				g.a1.addLabel(vec.get(i).name,(float)( 0.5f+Math.cos(2.0f*Math.PI*(ang+0.25f+val*0.5f))*radius*1.2f), 
						(float)(0.5f+Math.sin(2.0f*Math.PI*(ang+0.25f+val*0.5f))*radius*1.2f));
				
				
				obj.add(o);
				
				ang+=val;
		    }else{
		    	obj.add(new DrawObject());	
		    }
		}
		
		g.mObj=obj;
		g.mData=this.clone();
		
		return g;
	}
}
