package infovis.chartgenerators;

import infovis.Achsen;
import infovis.DrawObject;
import infovis.Graph;

import java.awt.Color;
import java.awt.geom.Line2D;
import java.util.Vector;

public class ScatterPlotGenerator extends DataCollection{

	public ScatterPlotGenerator(){}
	
	public Graph generate(){
		Graph g=new Graph(Graph.SCATTERPLOT);
		g.mData=this.clone();
		
		g.a1=new Achsen();
		
		Vector<DrawObject> obj=new Vector<DrawObject>();
		
		Float[] diff=getMinMax();
		
		for(int i=0; i<vec.size(); i++) {
			if(!vec.get(i).isNull()){
				DrawObject o=new DrawObject();
				
				o.mShape=(new ShapeGenerator()).Circle(0.02f);
				o.mPosition.setLocation( vec.get(i).x/diff[MaxX], vec.get(i).y/diff[MaxY]);
				o.mRotation=0.0f;
				o.mColor=new Color(0.0f, 0.0f, (float)getIndex(i)/(float)vec.size(), 0.9f);
				
				g.a1.addLabel(vec.get(i).name, vec.get(i).x/diff[MaxX], vec.get(i).y/diff[MaxY]-0.05f);
				
				
				obj.add(o);
			} else {
				obj.add(new DrawObject());
			}
		}
		
		g.mObj=obj;
		
		Float[] minmax=getMinMax();
		
		float diffX=minmax[MaxX];
		float diffY=minmax[MaxY];
		
		float X=minmax[MaxX];
		float Y=minmax[MaxY];
		
		for(int i=0; i<=X; i++){ 
			g.a1.lines.add(new Line2D.Float(0.0f, (float)i/X, 1.0f, (float)i/X));
			g.a1.addLabel(""+i, -0.05f, (float)i/X);
		}
		
		for(int i=0; i<=Y; i++){ 
			g.a1.lines.add(new Line2D.Float((float)i/Y, 0.0f, (float)i/Y, 1.0f));
			g.a1.addLabel(""+i,  (float)i/Y, -0.05f);
		}
		
		
		return g;
	}
	
}
