package infovis;

import java.awt.Color;

import infovis.blend.ColorBlend;
import infovis.blend.PositionBlend;
import infovis.blend.PositionRadialBlend;
import infovis.blend.RotationBlend;
import infovis.blend.ShapeBlend;
import java.util.*;

public class transitionGenerator {
	
	Graph mGraph=null;
	
	float DELAYDELTA=0.3f;
	
	public Graph getGraph(){
		return mGraph;
	}
	
	Transition generate(float duration, Graph src, Graph dst){
		
		Transition main=new Transition(duration*1000);
		Transition blendin=null, blendout=null, t=null;
		
		mGraph=src;
	
		// "copy" achses !!!
		if(dst.a1!=null) src.a2=dst.a1.clone(); else src.a2=null; 
		
		//find out if der are any axis to blend out / fade in ...
		float fadeIn=0.2f;
		float fadeOut=0.8f;
		
		if(src.a1!=null&&dst.a1!=null){
			blendin=new Transition(0.0f, fadeIn);
			t=new Transition(fadeIn, fadeOut);
			blendout=new Transition(fadeOut, 1.0f);	
		}
		
		if(src.a1==null&&dst.a1!=null){
			t=new Transition(0.0f, fadeOut);
			blendout=new Transition(fadeOut, 1.0f);				
		}

		if(src.a1!=null&&dst.a1==null){
			blendin=new Transition(0.0f, fadeIn);
			t=new Transition(fadeIn, 1.0f);			
		}
		
		if(src.a1==null&&dst.a1==null){
			t=new Transition(0.0f, 1.0f);				
		}
		
		main.add(t);
		
		if(blendin!=null) {
			blendin.add(new ColorBlend(src.a1,false));
			main.add(blendin);
		}
		
		if(blendout!=null) {
			blendout.add(new ColorBlend(src.a2,true));
			main.add(blendout);
		}
		
		
			
		if((src.mType==Graph.BARCHART)&&(dst.mType==Graph.BARCHART)){
				
			// blendin or fadeout
			if(src.mData.nrNoneEmpty()!=dst.mData.nrNoneEmpty()){
				
				if(src.mData.nrNoneEmpty()>dst.mData.nrNoneEmpty()){
					
					Transition t1=new Transition(0.0f, 0.5f);
					Transition t2=new Transition(0.5f, 1.0f);
					
					for(int i=0; i<src.mData.vec.size(); i++)
						
						if(dst.mData.vec.get(i).isNull()) {
							
							DrawObject dro=src.mObj.get(i).clone();
							
							float[] comp=dro.mColor.getComponents(null);
							dro.mColor=new Color(comp[0], comp[1],comp[2],0.0f);
							t1.add(new ColorBlend(src.mObj.get(i),src.mObj.get(i),dro));
						}
					
					t.add(t1);
					
					t2.addAll((new PositionBlend()).many(src,src,dst));
					t2.addAll((new ShapeBlend()).many(src,src,dst));
				
					t.add(t2);
					
				} else {
					
					Transition t1=new Transition(0.0f, 0.5f);
					Transition t2=new Transition(0.5f, 1.0f);
					
					t1.addAll((new PositionBlend()).many(src,src,dst));
					t1.addAll((new ShapeBlend()).many(src,src,dst));
				
					t.add(t1);
					
					for(int i=0; i<src.mData.vec.size(); i++){
						
						if(src.mData.vec.get(i).isNull()) {
							
							DrawObject dro=dst.mObj.get(i).clone();
							src.mObj.add(i,dro);
							
							float[] comp=dro.mColor.getComponents(null);
							dro.mColor=new Color(comp[0], comp[1],comp[2],0.0f);
							t2.add(new ColorBlend(src.mObj.get(i),dro, dst.mObj.get(i)));
						} 
					}
		
					t.add(t2);
					
				}
				
			} else	if(!dst.mData.orderingEquals()){
				
				for(int i=0; i<src.mData.vec.size(); i++){
					Random rand=new Random();
					
					DrawObject dro=dst.mObj.get(dst.mData.getIndex(i)).clone();
					dro.mPosition.y=src.mObj.get(i).mPosition.y;
					Transition t1=new Transition(0.0f+rand.nextFloat()*DELAYDELTA, 1.0f-rand.nextFloat()*DELAYDELTA);
					t1.add(new PositionBlend(src.mObj.get(i),src.mObj.get(i), dro));
					
					t.add(t1);
				}	
			} else {
			
			// or just a value change
			
			t.addAll((new PositionBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));

			}
		}

		if((src.mType==Graph.SCATTERPLOT)&&(dst.mType==Graph.SCATTERPLOT)){
				
			if(src.mData.nrNoneEmpty()!=dst.mData.nrNoneEmpty()){
				
				Transition t1=new Transition(0.0f, 0.5f);
				Transition t2=new Transition(0.5f, 1.0f);
				
				if(src.mData.nrNoneEmpty()>dst.mData.nrNoneEmpty()){
				
					for(int i=0; i<src.mData.vec.size(); i++)
						if(dst.mData.vec.get(i).isNull()) {
							
							DrawObject dro=src.mObj.get(i).clone();
							
							float[] comp=dro.mColor.getComponents(null);
							dro.mColor=new Color(comp[0], comp[1],comp[2],0.0f);
							t1.add(new ColorBlend(src.mObj.get(i),src.mObj.get(i),dro));
						}	
					
					t2.addAll((new PositionBlend()).many(src,src,dst));
					
				} else {
					
					t1.addAll((new PositionBlend()).many(src,src,dst));
					
					for(int i=0; i<src.mData.vec.size(); i++)
						if(src.mData.vec.get(i).isNull()){
							
							DrawObject dro=dst.mObj.get(i).clone();
							src.mObj.add(i,dro);
							
							float[] comp=dro.mColor.getComponents(null);
							dro.mColor=new Color(comp[0], comp[1],comp[2],0.0f);
							
							t2.add(new ColorBlend(src.mObj.get(i), dro, dst.mObj.get(i)));
						}
					
				}
				
				t.add(t1);
				t.add(t2);
			
			} else {
			
			// or just a value change
			
			t.addAll((new PositionBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));
		
			}
		}
		
		if((src.mType==Graph.BARCHART)&&(dst.mType==Graph.SCATTERPLOT)){
			
			Transition t1=new Transition(0.0f, 0.5f);
			Transition t2=new Transition(0.5f, 1.0f);
			
			t.add(t1);
			t.add(t2);
			
			Graph mid=src.clone();
			
			for(int i=0; i<src.mObj.size(); i++){
				mid.mObj.get(i).mPosition.y=dst.mObj.get(i).mPosition.y;	
			}
			
			t1.addAll((new PositionBlend()).many(src,src,mid));
			t1.addAll((new ShapeBlend()).many(src,src,dst));
			t2.addAll((new PositionBlend()).many(src,mid,dst));
			
		}
		
		if((src.mType==Graph.SCATTERPLOT)&&(dst.mType==Graph.BARCHART)){
			
			Transition t1=new Transition(0.0f, 0.5f);
			Transition t2=new Transition(0.5f, 1.0f);
			
			t.add(t1);
			t.add(t2);
			
			Graph mid=src.clone();
			
			for(int i=0; i<src.mObj.size(); i++){
				mid.mObj.get(i).mPosition.x=dst.mObj.get(i).mPosition.x;	
			}
			
			t1.addAll((new PositionBlend()).many(src,src,mid));
			t2.addAll((new ShapeBlend()).many(src,src,dst));
			t2.addAll((new PositionBlend()).many(src,mid,dst));
			
		}
		
		if((src.mType==Graph.BARCHART)&&(dst.mType==Graph.PIECHART)){
			
			t.addAll((new PositionRadialBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));	
		}
		
		if((src.mType==Graph.PIECHART)&&(dst.mType==Graph.BARCHART)){
			t.addAll((new PositionRadialBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));	
		}
		
		if((src.mType==Graph.SCATTERPLOT)&&(dst.mType==Graph.PIECHART)){	
			t.addAll((new PositionRadialBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));	
		}
		
		if((src.mType==Graph.PIECHART)&&(dst.mType==Graph.SCATTERPLOT)){	
			t.addAll((new PositionRadialBlend()).many(src,src,dst));
			t.addAll((new ShapeBlend()).many(src,src,dst));	
		}
		
		return main;
	}

}
